# 2ch trip generator plugin for Movable Type
# Original copyright (c) 2006, qyen
# Author: qyen (http://www.qyen.info)
# Released under the Artistic License
#
package MT::Plugin::Tripper;

use strict;
use MT;
use Jcode;
use vars qw($VERSION @ISA);

@ISA = qw(MT::Plugin);
$VERSION = '1.0';

our $self;

# generate Trip code
sub trip($){
	my $seed = shift;
	$seed = jcode($seed)->sjis ;
	my $salt = substr($seed, 1, 2);
	$salt =~ tr/\x00-\x20\x7B-\xFF/./;
	$salt =~ tr/\x3A-\x40\x5B-\x60/A-Ga-f/;
	return(substr(crypt($seed, $salt), -10));
}

sub doLog {
    my ($msg) = @_;
    use MT::Log;
    my $log = MT::Log->new;
    if ( defined( $msg ) ) {
	$log->message( $msg );
    }
			
    $log->save or die $log->errstr;
}



sub presave_comment {
	my ($eh, $app, $comment) = @_;	
	my $nick = $comment->author ;
	$nick =~ s/◆/◇/g;

	if (index($nick,'#')!=-1){
		my $i=index($nick,'#');
		my $base=substr($nick,0,$i);
		my $trip=trip(substr($nick,($i+1),length($nick)));
		$nick = $base.' ◆'.$trip;
	}
	$comment->author($nick);

    return 1;
}

sub install{
	my $plugin = new MT::Plugin::SpamLookup({
	        name => '2ch Trip generator',
        	version => $VERSION,
	        description => 'Generate 2ch(http://www.2ch.net/) trip.',
	        doc_link => 'http://www.qyen.info/2006/10/trip_for_mt333.html',
	        author_name => 'qyen',
	        author_link => 'http://www.qyen.info/',
		});
	our $self = $plugin;

	MT->add_plugin($plugin);
	require MT::Comment;

	MT->add_callback('CommentFilter', 10, 'Reject ASCII-only Comments', \&presave_comment);

}

package main;
MT::Plugin::Tripper::install();
1;
